## org.biojava.bio.gui.sequence
Class MultiLineRenderer

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.gui.sequence.MultiLineRenderer

All Implemented Interfaces:
  Serializable, SequenceRenderer, Changeable

Direct Known Subclasses:
  AbstractPeptideDigestRenderer

    public class MultiLineRenderer

extends AbstractChangeable
implements SequenceRenderer, Serializable

`MultiLineRenderer` is a `SequenceRenderer` which collects a number of other `SequenceRenderer`s each of which render their own view of a `Sequence`.

Author:
  Matthew Pocock, Keith James
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.gui.sequence.SequenceRenderer
`SequenceRenderer.RendererForwarder`

Field Summary
`protected List` `renderers`
`static ChangeType` `RENDERERS`

Constructor Summary
`MultiLineRenderer()`

Method Summary
`protected void` `_addRenderer(SequenceRenderer renderer)`
`protected void` `_removeRenderer(SequenceRenderer renderer)`
`void` `addRenderer(SequenceRenderer renderer)` `addRenderer` adds a renderer as a new track.
`void` `clearRenderers()` `clearRenderers` removes all renderers from this renderer.
`protected ChangeSupport` `getChangeSupport(ChangeType ct)` Called to retrieve the ChangeSupport for this object.
`double` `getDepth(SequenceRenderContext src)` Retrieve the depth of this renderer when rendering src.
`double` `getMinimumLeader(SequenceRenderContext src)` Retrieve the minimum leading distance for this renderer when rendering src.
`double` `getMinimumTrailer(SequenceRenderContext src)` Retrieve the minimum trailing distance for this renderer when rendering src.
`void` `paint(Graphics2D g, SequenceRenderContext src)` Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.
`SequenceViewerEvent` `processMouseEvent(SequenceRenderContext src, MouseEvent me, List path)` Produce a SequenceViewerEvent in response to a mouse gesture.
`void` `removeRenderer(SequenceRenderer renderer)` `removeRenderer` removes a renderer.

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### RENDERERS

    public static final ChangeType RENDERERS

### renderers

    protected List renderers

Constructor Detail

### MultiLineRenderer

    public MultiLineRenderer()

Method Detail

### getChangeSupport

    protected ChangeSupport getChangeSupport(ChangeType ct)

  Description copied from class: `AbstractChangeable`
  Called to retrieve the ChangeSupport for this object.

  Your implementation of this method should have the following structure: ``

       ChangeSupport cs = super.getChangeSupport(ct);

       if(someForwarder == null && ct.isMatching(SomeInterface.SomeChangeType)) {
         someForwarder = new ChangeForwarder(...

         this.stateVariable.addChangeListener(someForwarder, VariableInterface.AChange);
       }

       return cs;

  It is usual for the forwarding listeners (someForwarder in this example) to be transient and lazily instantiated. Be sure to register & unregister the forwarder in the code that does the ChangeEvent handling in setter methods.

  Overrides:
    `getChangeSupport` in class `AbstractChangeable`

### addRenderer

    public void addRenderer(SequenceRenderer renderer)
                     throws ChangeVetoException

  `addRenderer` adds a renderer as a new track.

  Parameters:
    `renderer` - a `SequenceRenderer` to add.
  Throws:
    `ChangeVetoException` - if the renderer cannot be added.

### _addRenderer

    protected void _addRenderer(SequenceRenderer renderer)

### removeRenderer

    public void removeRenderer(SequenceRenderer renderer)
                        throws ChangeVetoException

  `removeRenderer` removes a renderer.

  Parameters:
    `renderer` - a `SequenceRenderer` to remove.
  Throws:
    `ChangeVetoException` - if the renderer can not be removed.

### _removeRenderer

    protected void _removeRenderer(SequenceRenderer renderer)

### clearRenderers

    public void clearRenderers()
                        throws ChangeVetoException

  `clearRenderers` removes all renderers from this renderer.

  Throws:
    `ChangeVetoException` - if the renderers can not be cleared.

### getDepth

    public double getDepth(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the depth of this renderer when rendering src.

  The depth may vary between sequence panels - for example based upon sequence length. Each line of information in the SequenceRendererContext only renders a region of the sequence. The depth for one complete line may be different from that for another due to the sequence having more or less information in that region to show. For example, a feature renderer implementation may chose to collapse down to a depth of zero pixels if there are no features to render within a region.

  Specified by:
    `getDepth` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the depth of the renderer for that sequence panel

### getMinimumLeader

    public double getMinimumLeader(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum leading distance for this renderer when rendering src.

  The leading distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumLeader` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the leading distance of the renderer for that sequence panel

### getMinimumTrailer

    public double getMinimumTrailer(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum trailing distance for this renderer when rendering src.

  The trailing distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumTrailer` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the trailing distance of the renderer for that sequence panel

### paint

    public void paint(Graphics2D g,
                      SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.

  Specified by:
    `paint` in interface `SequenceRenderer`
  Parameters:
    `g` - the Graphics2D to render to
    `src` - the SequenceRenderContext that encapsulates the information to render

### processMouseEvent

    public SequenceViewerEvent processMouseEvent(SequenceRenderContext src,
                                                 MouseEvent me,
                                                 List path)

  Description copied from interface: `SequenceRenderer`
  Produce a SequenceViewerEvent in response to a mouse gesture.

  A SequenceRenderer that performs any form of coordinate remapping should ensure that it appropriately transforms the mouse event. However, in the SequenceViewerEvent returned, the MouseEvent should be in untransformed coordinates.

  The SequenceRenderer implementation should append itself to the path list before constructing the SequenceViewerEvent.

  Specified by:
    `processMouseEvent` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext currently in scope
    `me` - a MouseEvent that caused this request
    `path` - the List of SequenceRenderer instances passed through so far
  Returns:
    a SequenceViewerEvent encapsulating the mouse gesture